//+------------------------------------------------------------------+
//|                                              #MTF_HULL_TREND.mq4 |
//|------------------------------------------------------------------+

#property  indicator_separate_window
#property indicator_buffers  8
#property indicator_minimum  0
#property indicator_maximum  1
#property indicator_color1 Turquoise
#property indicator_color2 OrangeRed
#property indicator_color3 Gold
#property indicator_color4 Red
#property indicator_color5 Aqua
#property indicator_color6 Salmon
#property indicator_color7 Yellow
#property indicator_color8 Red
#property indicator_width7 3
#property indicator_width8 3

//---- input parameters
/*************************************************************************
PERIOD_M1   1
PERIOD_M5   5
PERIOD_M15  15
PERIOD_M30  30 
PERIOD_H1   60
PERIOD_H4   240
PERIOD_D1   1440
PERIOD_W1   10080
PERIOD_MN1  43200
You must use the numeric value of the timeframe that you want to use
when you set the TimeFrame' value with the indicator inputs.
---------------------------------------*/

extern int    TimeFrame = 15;
extern int FasterMA = 5;
extern int SlowerMA = 15;
extern int MA1_Type = 1;
extern int MA2_Type = 1;
extern int MACD_Fast = 8;
extern int MACD_Slow = 17;
extern int MACD_Signal = 9; 
extern int RSI = 21;
extern int Momentum = 14;
extern int DeMarker = 14;
extern int ADX = 14;
extern int ForceIndex = 14;
extern bool SoundAlert = true;
//---- indicator buffers
double Up[];
double Down[];
double CrossUp[];
double CrossDown[];
double TrendUp[];
double TrendDown[];
double MAUp[];
double MADown[];
double alertBar;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int init()
  {
   
//---- indicator line
   SetIndexStyle(0, DRAW_ARROW);
   SetIndexArrow(0,120);
   SetIndexBuffer(0, Up);
   SetIndexStyle(1, DRAW_ARROW);
   SetIndexArrow(1,120);
   SetIndexBuffer(1, Down);
   SetIndexStyle(2, DRAW_ARROW);
   SetIndexArrow(2, 251);
   SetIndexBuffer(2, CrossUp);
   SetIndexStyle(3, DRAW_ARROW);
   SetIndexArrow(3, 251);
   SetIndexBuffer(3, CrossDown);
   SetIndexStyle(4, DRAW_ARROW);
   SetIndexArrow(4, 110);
   SetIndexBuffer(4, TrendUp);
   SetIndexStyle(5, DRAW_ARROW);
   SetIndexArrow(5, 110);
   SetIndexBuffer(5, TrendDown);
   SetIndexStyle(6, DRAW_ARROW);
   SetIndexArrow(6, 233);
   SetIndexBuffer(6, MAUp);
   SetIndexStyle(7, DRAW_ARROW);
   SetIndexArrow(7, 234);
   SetIndexBuffer(7, MADown);
//---- name for DataWindow and indicator subwindow label   

   switch(TimeFrame)
   {
      case 1 : string TimeFrameStr="Period_M1"; break;
      case 5 : TimeFrameStr="Period_M5"; break;
      case 15 : TimeFrameStr="Period_M15"; break;
      case 30 : TimeFrameStr="Period_M30"; break;
      case 60 : TimeFrameStr="Period_H1"; break;
      case 240 : TimeFrameStr="Period_H4"; break;
      case 1440 : TimeFrameStr="Period_D1"; break;
      case 10080 : TimeFrameStr="Period_W1"; break;
      case 43200 : TimeFrameStr="Period_MN1"; break;
      default : TimeFrameStr="Current Timeframe";
   }
   IndicatorShortName("#MTF_Madro_Golden("+TimeFrameStr+")");

  }

//----

   return(0);
 
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int start()
  {

   datetime TimeArray[];
   int    i,limit,y=0,counted_bars=IndicatorCounted(); 

// Plot defined time frame on to current time frame

   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame); 
   
   limit= Bars-1;
   for(i=0,y=0;i<limit;i++)
   {
   if (Time[i]<TimeArray[y]) y++;

/***********************************************************   
   Add your main indicator loop below.  You can reference an existing
      indicator with its iName  or iCustom.
   Rule 1:  Add extern inputs above for all neccesary values   
   Rule 2:  Use 'TimeFrame' for the indicator time frame
   Rule 3:  Use 'y' for your indicator's shift value
 **********************************************************/  

   Up[i]=iCustom(Symbol(),TimeFrame,"__MadroGoldenFilter",0,y);
   Down[i]=iCustom(Symbol(),TimeFrame,"__MadroGoldenFilter",1,y); 
   CrossUp[i]=iCustom(Symbol(),TimeFrame,"__MadroGoldenFilter",2,y); 
   CrossDown[i]=iCustom(Symbol(),TimeFrame,"__MadroGoldenFilter",3,y); 
   TrendUp[i]=iCustom(Symbol(),TimeFrame,"__MadroGoldenFilter",4,y); 
   TrendDown[i]=iCustom(Symbol(),TimeFrame,"__MadroGoldenFilter",5,y); 
   if (Time[i]==TimeArray[y]) MAUp[i]=iCustom(Symbol(),TimeFrame,"__MadroGoldenFilter",6,y); 
   if (Time[i]==TimeArray[y]) MADown[i]=iCustom(Symbol(),TimeFrame,"__MadroGoldenFilter",7,y);
   if(i == 3 && MAUp[i] != EMPTY_VALUE && SoundAlert == true && Bars>alertBar) {Alert("#MTF GoldenMadro Up "," up= ",MAUp[i]," dn= ",MADown[i]," i= ",i," y= ",y + Symbol() + " on the " +  Period() + " minute chart.");alertBar = Bars;}
   if(i == 3 && MADown[i] != EMPTY_VALUE && SoundAlert == true && Bars>alertBar) {Alert("#MTF GoldenMadro Down "," up= ",MAUp[i]," dn= ",MADown[i]," i= ",i," y= ",y + Symbol() + " on the " + Period() + " minute chart.");alertBar = Bars;}
     } 
   return(0);
  }
//+------------------------------------------------------------------+